/*******************************************************************************
 * FoxDialogBoxBulkPurchase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDialogBoxBulkPurchase extends FoxDialogBox within FoxUI
    native(UI)
    config(UI);

struct native PurchaseItemEntry extends BaseStoreEntry
{
    var string sOrigCost;
    var string sCurrencyColor2;
};

var private transient array<string> BulkItemGuids;
var private transient array<string> BulkItemAttachments;
var private transient int BulkDiscountedTotalPrice;
var private transient float BulkDiscountAmount;
var const localized string locBPPurchasingTitle;
var const localized string locBPPurchasingText;
var const localized string locBPResultTitle;
var const localized string locBPFailed;
var const localized string locBPPriceMismatch;
var const localized string locBPNotEnoughFunds;
var const localized string locBPDiscountMismatch;
var const localized string locBPMidPurchaseFailure;
var const localized string locBPInvalidActivationType;
var const localized string locBPCannotPurchaseItem;
var const localized string locBPItemNotFound;
var const localized string locBPNoItemSpecified;

function ShowDialog(DialogBoxProperties Properties)
{
    Properties.TitleText = Localize("FOXDIALOGBOXBULK", "headerLabel", "FoxMenuUI");
    Properties.DialogType = 11;
    Properties.OnDialogButtonPressed = PurchaseItems;
    super.ShowDialog(Properties);
    SetupBulkPurchaseDialog(Properties);
    //return;    
}

function SetupBulkPurchaseDialog(const out DialogBoxProperties Properties)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x189
    if(BoundObject != none)
    {
        BoundObject.SetString("zenTextColor", CurrencyColors[1]);
        BoundObject.SetString("gpTextColor", CurrencyColors[0]);
        BoundObject.SetString("zenIcon", Outer.MarkupImageString(Outer.CurrencyInfo[1].sIconSmall));
        BoundObject.SetString("gpIcon", Outer.MarkupImageString(Outer.CurrencyInfo[0].sIconSmall));
    }
    SetGPAndZP(GetCurrencyAmount(0), GetCurrencyAmount(1), (GetCurrencyAmount(0)) >= 0, (GetCurrencyAmount(1)) >= 0);
    PopulateItemAndPricingData(Properties.BulkPurchaseList);
    //return;    
}

function PopulateItemAndPricingData(const out array<BulkPurchaseItemInfo> ItemsList)
{
    local GFxObject FinalPrice;
    local array<GFxObject> PricingData;
    local PurchaseItemEntry PurchaseItem;
    local array<PurchaseItemEntry> PurchaseItemEntries;
    local FoxItemCacheStore StoreCache;
    local StoreMetaData StoreItem;
    local BaseInventoryEntry ItemTile;
    local int OrigPrice, OrigTotalPrice, I, DiscountPercentage;
    local string DiscountStr;

    // End:0x633
    if(class'FoxDataStore_StoreData'.static.GetCachedStore(StoreCache))
    {
        BulkDiscountAmount = CalculateBulkPurchaseDiscount(ItemsList.Length);
        DiscountPercentage = int(((float(1) - BulkDiscountAmount) * 100.0) + 0.00010);
        I = 0;
        J0x7C:
        // End:0x36B [Loop If]
        if(I < ItemsList.Length)
        {
            // End:0x35D
            if(StoreCache.GetCachedItemByUnlockID(StoreItem, ItemsList[I].ItemUID) && Outer.GetItemTileFromUnlockID(ItemTile, ItemsList[I].ItemUID,, ItemsList[I].AssociatedUID))
            {
                class'FoxStoreMetaData'.static.GetPremiumPermPrice(StoreItem, OrigPrice,, false);
                // End:0x1A8
                if(OrigPrice == -1)
                {
                }
                // End:0x35D
                else
                {
                    OrigTotalPrice += OrigPrice;
                    BulkItemGuids.AddItem(StoreItem.ItemGuid);
                    BulkItemAttachments.AddItem(string(ItemsList[I].AssociatedUID));
                    PurchaseItem = ItemTile;
                    PurchaseItem.sOrigCost = string(OrigPrice);
                    PurchaseItem.sItemZenCost = (string(DiscountPercentage) $ "%") @ (Localize("FOXDIALOGBOXBULK", "off", "FoxMenuUI"));
                    PurchaseItem.sPremCurrencyIcon = Outer.MarkupImageString(Outer.CurrencyInfo[1].sIconSmall);
                    PurchaseItem.sCurrencyColor2 = CurrencyColors[1];
                    PurchaseItemEntries.AddItem(PurchaseItem);
                }
            }
            ++ I;
            // [Loop Continue]
            goto J0x7C;
        }
        as_SetItemsData(PurchaseItemEntries);
        DiscountStr = ((Localize("FOXDIALOGBOXBULK", "save", "FoxMenuUI")) @ string(DiscountPercentage)) $ "%";
        BulkDiscountedTotalPrice = int(float(OrigTotalPrice) * BulkDiscountAmount);
        FinalPrice = Outer.CreateObject("Object");
        FinalPrice.SetString("sCurrencyIcon", Outer.MarkupImageString(Outer.CurrencyInfo[1].sIconSmall));
        FinalPrice.SetString("sCurrencyColor", CurrencyColors[1]);
        FinalPrice.SetString("sOrigCost", string(OrigTotalPrice));
        FinalPrice.SetString("sItemCost", string(BulkDiscountedTotalPrice));
        FinalPrice.SetString("sDiscountAmount", DiscountStr);
        FinalPrice.SetString("sLabel", Localize("FOXDIALOGBOXBULK", "priceButtonLabel", "FoxMenuUI"));
        FinalPrice.SetBool("bSelected", true);
        PricingData.AddItem(FinalPrice);
        as_SetPricingData(PricingData);
    }
    // End:0x662
    if(PurchaseItemEntries.Length == 0)
    {
        Outer.CloseDialogBox();
    }
    //return;    
}

function as_SetPricingData(array<GFxObject> Pricing)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x4F
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("pricingData");
    }
    //return;    
}

function as_SetItemsData(array<PurchaseItemEntry> ItemEntries)
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x53
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("setAllItemsData");
    }
    //return;    
}

function float CalculateBulkPurchaseDiscount(const int NumItems)
{
    local FoxItemCacheStore StoreCache;
    local float DiscountPerItem, DiscountMax, Discount;

    // End:0x15
    if(NumItems <= 1)
    {
        return 1.0;
    }
    // End:0xD1
    if(class'FoxDataStore_StoreData'.static.GetCachedStore(StoreCache))
    {
        DiscountPerItem = StoreCache.GetBulkDiscountPerItem();
        DiscountMax = StoreCache.GetBulkDiscountMax();
        Discount = FMin(DiscountMax, float(NumItems - 1) * DiscountPerItem);
        return 1.0 - Discount;
    }
    return 1.0;
    //return ReturnValue;    
}

function PurchaseItems(FoxDialogBoxBase.EDialogBoxConfirmType Selection)
{
    local DialogBoxProperties Properties;

    // End:0x1B4
    if(Selection == 0)
    {
        Outer.OnlineSub.StoreInterface.AddPurchaseMultipleItemsCompleteDelegate(0, OnBulkPurchaseComplete);
        Outer.OnlineSub.StoreInterface.PurchaseMultipleItems(BulkItemGuids, BulkItemAttachments, BulkDiscountedTotalPrice, BulkDiscountAmount, 0, 1);
        Properties.DialogType = 0;
        Properties.TitleText = locBPPurchasingTitle;
        Properties.BodyText = locBPPurchasingText;
        Properties.bShowTimer = true;
        Properties.bCloseOnButtonPress = false;
        Outer.ShowDialogBox(Properties);
    }
    //return;    
}

function OnBulkPurchaseComplete(const Engine.OnlineSubsystemTypes.EPurchaseMultipleResult Result, const array<string> InItems)
{
    local FoxServerConnection ServerConn;
    local FoxItemCacheInventory InventoryCache;
    local array<InventoryMetaData> UpdatedItems;
    local FoxItemCacheLoadouts LoadoutsCache;
    local DialogBoxProperties Properties;
    local string ErrorStr;

    Outer.OnlineSub.StoreInterface.ClearPurchaseMultipleItemCompleteDelegate(0, OnBulkPurchaseComplete);
    ServerConn = FoxServerConnection(Outer.PCOwner.WorldInfo.ServerConn);
    // End:0x163
    if(((ServerConn != none) && class'FoxDataStore_StoreData'.static.GetCachedInventory(InventoryCache)) && InventoryCache.HasUpdatedItems(UpdatedItems,, true))
    {
        InventoryCache.MergeUpdatedItems();
        ServerConn.ApplyInventoryFromCache();
    }
    // End:0x334
    if(class'FoxDataStore_StoreData'.static.GetCachedLoadouts(LoadoutsCache))
    {
        LoadoutsCache.ValidateInvalidLoadouts();
        // End:0x334
        if((((Outer.PCOwner != none) && Outer.PCOwner.DynamicUI != none) && Outer.PCOwner.DynamicUI.Menu != none) && Outer.PCOwner.DynamicUI.Menu.ArmoryInfo != none)
        {
            Outer.PCOwner.DynamicUI.Menu.ArmoryInfo.OnBulkPurchaseComplete();
        }
    }
    Outer.CloseDialogBox();
    switch(Result)
    {
        // End:0x36E
        case 1:
            // End:0x464
            break;
        // End:0x389
        case 0:
            ErrorStr = locBPFailed;
            // End:0x464
            break;
        // End:0x3A4
        case 2:
            ErrorStr = locBPPriceMismatch;
            // End:0x464
            break;
        // End:0x3BF
        case 3:
            ErrorStr = locBPNotEnoughFunds;
            // End:0x464
            break;
        // End:0x3DA
        case 4:
            ErrorStr = locBPDiscountMismatch;
            // End:0x464
            break;
        // End:0x3F5
        case 5:
            ErrorStr = locBPMidPurchaseFailure;
            // End:0x464
            break;
        // End:0x410
        case 6:
            ErrorStr = locBPInvalidActivationType;
            // End:0x464
            break;
        // End:0x42B
        case 7:
            ErrorStr = locBPCannotPurchaseItem;
            // End:0x464
            break;
        // End:0x446
        case 8:
            ErrorStr = locBPItemNotFound;
            // End:0x464
            break;
        // End:0x461
        case 9:
            ErrorStr = locBPNoItemSpecified;
            // End:0x464
            break;
        // End:0xFFFF
        default:
            // End:0x549
            if(Result != 1)
            {
                Properties.DialogType = 1;
                Properties.TitleText = locBPResultTitle;
                Properties.BodyText = ErrorStr;
                Properties.bShowTimer = false;
                Properties.bCloseOnButtonPress = true;
                Outer.ShowDialogBox(Properties);
            }
            //return;
    }    
}

defaultproperties
{
    locBPPurchasingTitle="PURCHASING ITEMS"
    locBPPurchasingText="Waiting for purchase transactions to finish."
    locBPResultTitle="Bulk Purchase Result"
    locBPFailed="Bulk purchasing failed, please try again."
    locBPPriceMismatch="Bulk pricing mismatch."
    locBPNotEnoughFunds="Not enough funds to complete bulk purchase."
    locBPDiscountMismatch="Bulk purchase discount mismatch."
    locBPMidPurchaseFailure="Bulk purchasing failed during a transaction, please try again."
    locBPInvalidActivationType="Bulk purchasing provided invalid activation data."
    locBPCannotPurchaseItem="Unpurchasable item provided for bulk purchasing."
    locBPItemNotFound="Bulk purchase item specified was not found."
    locBPNoItemSpecified="No items provided to bulk purchase."
}